-- DATABASE RIVISTE -----------------------------------------------------------

DROP TABLE Articolo;
DROP TABLE Rivista;

CREATE TABLE Rivista (
	CodR CHAR(4) NOT NULL,
	NomeR VARCHAR(64) NOT NULL,
	Editore VARCHAR(64) NOT NULL,
	PRIMARY KEY(CodR)
);

CREATE TABLE Articolo (
	CodA SMALLINT NOT NULL,
	Titolo VARCHAR(64) NOT NULL,
	Argomento VARCHAR(64) NOT NULL,
	CodR CHAR(4),
	PRIMARY KEY (CodA),
	FOREIGN KEY (CodR) REFERENCES Rivista(CodR)
 		ON DELETE CASCADE
);

INSERT INTO Rivista VALUES ('R1', 'MotorStyle', 'Giunti');
INSERT INTO Rivista VALUES ('R2', 'Al Volante', 'Mondadori');
INSERT INTO Rivista VALUES ('R3', 'Due Ruote', 'GEDI');
INSERT INTO Rivista VALUES ('R4', 'In Sella', 'UTET');
INSERT INTO Rivista VALUES ('R5', 'Quattroruote', 'Adelphi');
INSERT INTO Rivista VALUES ('R6', 'Ruoteclassiche', 'Bompiani');
INSERT INTO Rivista VALUES ('R7', 'Evo', 'Giunti');
INSERT INTO Rivista VALUES ('R8', 'Gente Motori', 'Mondadori');
INSERT INTO Rivista VALUES ('R9', 'Auto.It', 'Rizzoli');
INSERT INTO Rivista VALUES ('R10', 'Panoramauto', 'Rizzoli');

INSERT INTO Articolo VALUES (101, 'Articolo_101', 'Motociclismo', 'R3');
INSERT INTO Articolo VALUES (102, 'Articolo_102', 'Auto', 'R9');
INSERT INTO Articolo VALUES (103, 'Articolo_103', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (104, 'Articolo_104', 'Vela', 'R10');
INSERT INTO Articolo VALUES (105, 'Articolo_105', 'Running', 'R5');
INSERT INTO Articolo VALUES (106, 'Articolo_106', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (107, 'Articolo_107', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (108, 'Articolo_108', 'Auto', 'R8');
INSERT INTO Articolo VALUES (109, 'Articolo_109', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (110, 'Articolo_110', 'Auto', 'R1');
INSERT INTO Articolo VALUES (111, 'Articolo_111', 'Ciclismo', 'R2');
INSERT INTO Articolo VALUES (112, 'Articolo_112', 'Vela', 'R5');
INSERT INTO Articolo VALUES (113, 'Articolo_113', 'Running', 'R3');
INSERT INTO Articolo VALUES (114, 'Articolo_114', 'Nuoto', 'R10');
INSERT INTO Articolo VALUES (115, 'Articolo_115', 'Motociclismo', 'R6');
INSERT INTO Articolo VALUES (116, 'Articolo_116', 'Auto', 'R7');
INSERT INTO Articolo VALUES (117, 'Articolo_117', 'Motociclismo', 'R8');
INSERT INTO Articolo VALUES (118, 'Articolo_118', 'Auto', 'R6');
INSERT INTO Articolo VALUES (119, 'Articolo_119', 'Ciclismo', 'R7');
INSERT INTO Articolo VALUES (120, 'Articolo_120', 'Vela', 'R3');
INSERT INTO Articolo VALUES (121, 'Articolo_121', 'Running', 'R6');
INSERT INTO Articolo VALUES (122, 'Articolo_122', 'Nuoto', 'R5');
INSERT INTO Articolo VALUES (123, 'Articolo_123', 'Motociclismo', 'R1');
INSERT INTO Articolo VALUES (124, 'Articolo_124', 'Auto', 'R9');
INSERT INTO Articolo VALUES (125, 'Articolo_125', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (126, 'Articolo_126', 'Vela', 'R3');
INSERT INTO Articolo VALUES (127, 'Articolo_127', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (128, 'Articolo_128', 'Nuoto', 'R8');
INSERT INTO Articolo VALUES (129, 'Articolo_129', 'Motociclismo', 'R4');
INSERT INTO Articolo VALUES (130, 'Articolo_130', 'Auto', 'R1');

-- DATABASE VELISTI -----------------------------------------------------------

DROP TABLE Prenotazioni;
DROP TABLE Velisti;
DROP TABLE Barche;

CREATE TABLE Velisti (
	Vid CHAR(4) NOT NULL,
	VNome VARCHAR(64) NOT NULL,
	Esperienza VARCHAR(64),
	DataNascita CHAR(10) NOT NULL,
	PRIMARY KEY(Vid)
);

CREATE TABLE Barche (
	Bid SMALLINT NOT NULL,
	BNome VARCHAR(64) NOT NULL,
	Colore VARCHAR(16),
	PRIMARY KEY(Bid)
);

CREATE TABLE Prenotazioni (
	Vid CHAR(4) NOT NULL,
	Bid SMALLINT NOT NULL,
	Data CHAR(10) NOT NULL,
	PRIMARY KEY (Vid, Bid,  Data),
	FOREIGN KEY (Vid) REFERENCES Velisti(Vid)
 		ON DELETE CASCADE,
	FOREIGN KEY (Bid) REFERENCES Barche(Bid)
 		ON DELETE CASCADE
);

INSERT INTO Velisti VALUES ('V1', 'Enrico', 'Buona', '1989/10/23');
INSERT INTO Velisti VALUES ('V2', 'Riccardo', 'Ottima', '1988/05/09');
INSERT INTO Velisti VALUES ('V3', 'Christian', 'Media', '1991/02/11');
INSERT INTO Velisti VALUES ('V4', 'Giorgio', 'Media', '1984/11/18');
INSERT INTO Velisti VALUES ('V5', 'Alberto', 'Buona', '1991/04/23');
INSERT INTO Velisti VALUES ('V6', 'Gaia', 'Buona', '1988/12/09');
INSERT INTO Velisti VALUES ('V7', 'Gianluca', 'Buona', '1990/02/15');
INSERT INTO Velisti VALUES ('V8', 'Alessandro', 'Ottima', '1990/05/19');
INSERT INTO Velisti VALUES ('V9', 'Greta', 'Media', '1992/02/13');
INSERT INTO Velisti VALUES ('V10', 'Michele', 'Ottima', '1985/08/28');

INSERT INTO Barche VALUES (101, 'Michela', 'Rosso');
INSERT INTO Barche VALUES (102, 'Maria', 'Verde');
INSERT INTO Barche VALUES (103, 'Cristina', 'Rosso');
INSERT INTO Barche VALUES (104, 'Arianna', 'Bianco');
INSERT INTO Barche VALUES (105, 'Stefania', 'Rosso');
INSERT INTO Barche VALUES (106, 'Gaia', 'Verde');
INSERT INTO Barche VALUES (107, 'Arianna', 'Verde');
INSERT INTO Barche VALUES (108, 'Debora', 'Rosso');
INSERT INTO Barche VALUES (109, 'Francesca', 'Bianco');
INSERT INTO Barche VALUES (110, 'Greta', 'Rosso');

INSERT INTO Prenotazioni VALUES ('V3', 109, '2019/04/19');
INSERT INTO Prenotazioni VALUES ('V6', 102, '2019/07/17');
INSERT INTO Prenotazioni VALUES ('V2', 106, '2019/09/08');
INSERT INTO Prenotazioni VALUES ('V1', 102, '2019/03/10');
INSERT INTO Prenotazioni VALUES ('V1', 107, '2019/08/20');
INSERT INTO Prenotazioni VALUES ('V2', 104, '2019/12/05');
INSERT INTO Prenotazioni VALUES ('V1', 102, '2019/04/07');
INSERT INTO Prenotazioni VALUES ('V7', 108, '2019/03/06');
INSERT INTO Prenotazioni VALUES ('V7', 110, '2019/07/06');
INSERT INTO Prenotazioni VALUES ('V2', 106, '2019/11/27');
INSERT INTO Prenotazioni VALUES ('V8', 108, '2019/07/02');
INSERT INTO Prenotazioni VALUES ('V8', 108, '2019/09/17');
INSERT INTO Prenotazioni VALUES ('V10', 105, '2019/05/15');
INSERT INTO Prenotazioni VALUES ('V7', 109, '2019/05/17');
INSERT INTO Prenotazioni VALUES ('V1', 104, '2019/05/29');
INSERT INTO Prenotazioni VALUES ('V6', 103, '2019/07/27');
INSERT INTO Prenotazioni VALUES ('V10', 104, '2019/09/25');
INSERT INTO Prenotazioni VALUES ('V5', 104, '2019/10/20');
INSERT INTO Prenotazioni VALUES ('V6', 102, '2019/11/20');
INSERT INTO Prenotazioni VALUES ('V1', 104, '2019/08/29');
INSERT INTO Prenotazioni VALUES ('V6', 106, '2019/11/17');
INSERT INTO Prenotazioni VALUES ('V1', 110, '2019/07/20');
INSERT INTO Prenotazioni VALUES ('V7', 107, '2019/12/10');
INSERT INTO Prenotazioni VALUES ('V7', 108, '2019/08/14');
INSERT INTO Prenotazioni VALUES ('V10', 103, '2019/10/07');
INSERT INTO Prenotazioni VALUES ('V2', 106, '2019/02/19');
INSERT INTO Prenotazioni VALUES ('V6', 108, '2019/04/08');
INSERT INTO Prenotazioni VALUES ('V8', 103, '2019/03/09');
INSERT INTO Prenotazioni VALUES ('V2', 107, '2019/02/14');
INSERT INTO Prenotazioni VALUES ('V1', 103, '2019/04/09');