--=========================================================
--  Esercizio 1 - DATABASE RIVISTE
-- ========================================================

-- Introdurre ed eseguire (una volta) la seguente istruzione
-- se si utilizza MySQL:
-- USE Riviste;

-----------------------------------------------------------
-- (a) Trovare il codice e il nome delle riviste che hanno
--     pubblicato almeno un Articolo di argomento
--     'Motociclismo'.
SELECT	DISTINCT R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR = A.CodR
		AND	Argomento = 'Motociclismo';
--
SELECT	CodR, NomeR
FROM	Rivista
WHERE 	CodR IN (
			SELECT 	CodR
			FROM 	Articolo
			WHERE 	Argomento = 'Motociclismo'
		);
--
SELECT 	CodR, NomeR
FROM 	Rivista R
WHERE 	EXISTS (
			SELECT	*
			FROM 	Articolo A
			WHERE 	A.CodR = R.CodR
			AND Argomento = 'Motociclismo'
		);
		
-----------------------------------------------------------
-- (b) Trovare il codice e il nome delle riviste che non
--     hanno mai pubblicato articoli di argomento
--     'Motociclismo'.
SELECT	CodR, NomeR
FROM	Rivista
WHERE 	CodR NOT IN (
			SELECT	CodR
			FROM	Articolo
			WHERE 	Argomento = 'Motociclismo'
		);
--
SELECT	CodR, NomeR
FROM 	Rivista R
WHERE 	NOT EXISTS (
			SELECT	*
			FROM 	Articolo A
			WHERE	A.CodR = R.CodR
			AND 	Argomento = 'Motociclismo'
		);

-----------------------------------------------------------
-- (c) Trovare il codice e il nome delle riviste che
--     hanno pubblicato solo articoli di argomento
--     'Motociclismo'.
SELECT	DISTINCT R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR = A.CodR
		AND R.CodR NOT IN (
			SELECT CodR
			FROM	Articolo
			WHERE	Argomento <> 'Motociclismo'
		);
--
SELECT	DISTINCT R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR = A.CodR
		AND NOT EXISTS (
			SELECT	*
			FROM 	Articolo A2
			WHERE 	A2.CodR = R.CodR
					AND Argomento <> 'Motociclismo'
		);
		
-----------------------------------------------------------
-- (d) Trovare il codice e il nome delle riviste che
--     pubblicano articoli di argomento 'Motociclismo'
--     oppure 'Auto'.
SELECT	DISTINCT R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR=A.CodR
		AND
		(Argomento = 'Motociclismo' OR Argomento = 'Auto');
		
-----------------------------------------------------------
-- (e) Trovare il codice e il nome delle riviste che
--     pubblicano articoli di entrambi gli argomenti
--     'Motociclismo' e 'Auto'.
SELECT	DISTINCT R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR = A.CodR
		AND Argomento = 'Motociclismo'
		AND R.CodR IN (
			SELECT	CodR
			FROM	Articolo
			WHERE	Argomento = 'Auto'
		);
--
SELECT	CodR, NomeR
FROM	Rivista
WHERE	CodR IN (
			SELECT	CodR
			FROM	Articolo
			WHERE	Argomento = 'Motociclismo'
		)
		AND CodR IN (
			SELECT	CodR
			FROM	Articolo
			WHERE Argomento = 'Auto'
		);
		
-----------------------------------------------------------
-- (f) Trovare il codice e il nome delle riviste che hanno
--     pubblicato almeno 2 articoli di argomento
--     'Motociclismo'.
SELECT	R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE	R.CodR = A.CodR
		AND Argomento = 'Motociclismo'
GROUP 	BY R.CodR, NomeR
HAVING 	COUNT(*) >= 2;		

-----------------------------------------------------------
-- (g) Trovare il codice e il nome delle riviste che hanno
--     pubblicato un solo Articolo di argomento
--     'Motociclismo' (possono aver scritto un numero
--     qualsiasi di articoli su altri argomenti).
SELECT	R.CodR, NomeR
FROM	Rivista R, Articolo A
WHERE 	R.CodR = A.CodR
		AND Argomento = 'Motociclismo'
GROUP 	BY R.CodR, NomeR
HAVING 	COUNT(*) = 1;

SELECT  CodA, Argomento
FROM    Articolo
WHERE   CodR = 'R4';

--=========================================================
--  Esercizio 2 - DATABASE VELISTI
-- ========================================================

-- Introdurre ed eseguire (una volta) la seguente istruzione
-- se si utilizza MySQL:
-- USE Velisti;

-----------------------------------------------------------
-- (a) Trovare i codici e i nomi dei velisti che hanno
--     prenotato una barca rossa oppure una barca verde
SELECT  DISTINCT V.Vid, VNome
FROM    Velisti V, Prenotazioni P, Barche B
WHERE   V.Vid = P.Vid AND B.Bid = P.Bid
        AND (Colore = 'Rosso' OR Colore = 'Verde');

SELECT  Vid, VNome
FROM    Velisti V
WHERE   Vid IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE B.Bid = P.Bid
            AND (Colore = 'Rosso' OR Colore = 'Verde')
        );

-----------------------------------------------------------
-- (b) Trovare i codici e i nomi dei velisti che hanno
--     prenotato una barca rossa e una verde
SELECT  DISTINCT V.Vid, VNome
FROM    Velisti V, Prenotazioni P, Barche B
WHERE   V.Vid = P.Vid
        AND B.Bid = P.Bid
        AND Colore = 'Rosso'
        AND V.Vid IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND Colore = 'Verde'
        );

SELECT  Vid, VNome
FROM    Velisti V
WHERE   Vid IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND Colore = 'Rosso'
        )
        AND Vid IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND Colore = 'Verde'
        );

-----------------------------------------------------------
-- (c) Trovare i codici dei velisti che non hanno mai
--     prenotato una barca rossa
SELECT  Vid
FROM    Velisti V
WHERE   Vid NOT IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND Colore = 'Rosso'
        );
        
-----------------------------------------------------------
-- (d) Trovare Trovare i codici e i nomi dei velisti che
--     non hanno mai prenotato una barca rossa
SELECT  Vid, VNome
FROM    Velisti V
WHERE   Vid NOT IN (
            SELECT  Vid
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND Colore = 'Rosso'
        );

SELECT  Vid, VNome
FROM    Velisti V
WHERE   NOT EXISTS (
            SELECT  *
            FROM    Prenotazioni P, Barche B
            WHERE   B.Bid = P.Bid
                    AND V.Vid = P.Vid
                    AND Colore = 'Rosso'
        );
        
-----------------------------------------------------------
-- (e) Trovare i codici e i nomi dei velisti che hanno
--     prenotato almeno due barche diverse        
SELECT  V.Vid, VNome
FROM    Velisti V, Prenotazioni P
WHERE   V.Vid = P.Vid
GROUP   BY V.Vid, VNome
HAVING  COUNT(DISTINCT Bid) >= 2;

SELECT  Vid, VNome
FROM    Velisti V
WHERE   Vid IN (
            SELECT  Vid
            FROM    Prenotazioni
            GROUP   BY Vid
            HAVING  COUNT(DISTINCT Bid) >= 2
        );
        
-----------------------------------------------------------
-- (f) Trovare i codici e i nomi dei velisti che hanno
--     prenotato almeno tre barche diverse
-- Soluzione come (e) con 3 al posto di 2

-----------------------------------------------------------
-- (g) Trovare i codici e i nomi dei velisti che hanno
--     effettuato almeno tre prenotazioni
SELECT  V.Vid, VNome
FROM    Velisti V, Prenotazioni P
WHERE   V.Vid = P.Vid
GROUP   BY V.Vid, VNome
HAVING  COUNT(*) >= 3;

SELECT  Vid, VNome
FROM    Velisti V
WHERE   Vid IN (
            SELECT  Vid
            FROM    Prenotazioni
            GROUP   BY Vid
            HAVING COUNT(*) >= 3
        );
